push sheeet
Some checks failed
Periodic Merges (6h) / master → staging-nixos (push) Failing after 12m50s
Periodic Merges (6h) / master → staging-next (push) Failing after 12m54s
Periodic Merges (24h) / merge-base(master,staging) → haskell-updates (push) Failing after 11m54s
Periodic Merges (6h) / staging-next → staging (push) Failing after 12m13s
Periodic Merges (24h) / staging-next-25.05 → staging-25.05 (push) Failing after 13m24s
Periodic Merges (24h) / release-25.05 → staging-next-25.05 (push) Failing after 14m28s

This commit is contained in:
Dark Steveneq
2025-10-09 14:15:47 +02:00
commit 646b892680
49168 changed files with 5897842 additions and 0 deletions

View File

@@ -0,0 +1,6 @@
echo "getting $url${rev:+ ($rev)} into $out"
hg clone --insecure "$url" hg-clone
hg archive -q$subrepoClause -y ${rev:+-r "$rev"} --cwd hg-clone $out
rm -f $out/.hg_archival.txt

View File

@@ -0,0 +1,48 @@
{
lib,
stdenvNoCC,
mercurial,
}:
lib.extendMkDerivation {
constructDrv = stdenvNoCC.mkDerivation;
extendDrvArgs =
finalAttrs:
{
name ? null,
url,
rev ? null,
sha256 ? null,
hash ? null,
fetchSubrepos ? false,
preferLocalBuild ? true,
}:
# TODO: statically check if mercurial has https support if the url starts with https.
{
name = "hg-archive" + (lib.optionalString (name != null) "-${name}");
builder = ./builder.sh;
nativeBuildInputs = [ mercurial ];
impureEnvVars = lib.fetchers.proxyImpureEnvVars;
subrepoClause = lib.optionalString fetchSubrepos "S";
outputHashAlgo = if finalAttrs.hash != null && finalAttrs.hash != "" then null else "sha256";
outputHashMode = "recursive";
outputHash = lib.throwIf (hash != null && sha256 != null) "Only one of sha256 or hash can be set" (
if finalAttrs.hash != null then
finalAttrs.hash
else if sha256 != null then
sha256
else
""
);
inherit url rev hash;
inherit preferLocalBuild;
};
# No ellipsis
inheritFunctionArgs = false;
}

View File

@@ -0,0 +1,84 @@
#! /usr/bin/env bash
set -e
url=$1
rev=$2
expHash=$3
hashType="${NIX_HASH_ALGO:-sha256}"
hashFormat=${hashFormat:-"--base32"}
rev="${rev:-tip}"
LOG() {
echo "$@" >&2
}
die() {
LOG "$@"
exit 1
}
if [[ -z "$url" || "$url" == "--help" ]]; then
die "Usage: nix-prefetch-hg URL [rev [EXPECTED-HASH]]"
fi
if [[ "${fetchSubrepos:-0}" == 1 ]]; then
subrepoClause=S
else
subrepoClause=
fi
# If the hash was given, a file with that hash may already be in the
# store.
if [[ -n "$expHash" ]]; then
finalPath=$(nix-store --print-fixed-path --recursive "$hashType" "$expHash" hg-archive)
if ! nix-store --check-validity "$finalPath" 2> /dev/null; then
finalPath=
fi
hash="$expHash"
fi
# If we don't know the hash or a path with that hash doesn't exist,
# download the file and add it to the store.
if [[ -z "$finalPath" ]]; then
# nix>=2.20 rejects adding symlinked paths to the store, so use realpath
# to resolve to a physical path. https://github.com/NixOS/nix/issues/11941
tmpPath="$(realpath "$(mktemp -d --tmpdir hg-checkout-tmp-XXXXXXXX)")"
cleanup() { x=$?; rm -rf "$tmpPath"; exit $x; }; trap cleanup EXIT
tmpArchive="$tmpPath/hg-archive"
# Perform the checkout.
if [[ "$url" != /* ]]; then
tmpClone="$tmpPath/hg-clone"
hg clone -q -y -U "$url" "$tmpClone" >&2
else
tmpClone=$url
fi
hg archive -q$subrepoClause -y -r "$rev" --cwd "$tmpClone" "$tmpArchive"
rm -f "$tmpArchive/.hg_archival.txt"
LOG "hg revision is $(cd "$tmpClone"; hg id -r "$rev" -i)"
# Compute the hash.
hash=$(nix-hash --type "$hashType" "$hashFormat" "$tmpArchive")
if [[ -z "$QUIET" ]]; then LOG "hash is $hash"; fi
# Add the downloaded file to the Nix store.
finalPath=$(nix-store --add-fixed --recursive "$hashType" "$tmpArchive")
if [[ -n "$expHash" && "$expHash" != "$hash" ]]; then
die "ERROR: hash mismatch for URL \`$url'"
fi
fi
if [[ -z "$QUIET" ]]; then LOG "path is $finalPath"; fi
echo "$hash"
if [[ -n "$PRINT_PATH" ]]; then
echo "$finalPath"
fi